!
!   AUTOGENERATED FILE, DON'T MODIFY!
!
!    Base file: ../../../scales-ppm/src/ppm/ppm_ptr_bnds_remap.f90.m4
!
!> @file ppm_ptr_bnds_remap.f90
!! @brief work-around for compilers lacking remapping of pointer bounds
!!
!!
!! @copyright Copyright  (C)  2016  Thomas Jahns <jahns@dkrz.de>
!!
!! @version 1.0
!! @author Thomas Jahns <jahns@dkrz.de>
!!         Moritz Hanke <hanke@dkrz.de>
!
! Maintainer: Thomas Jahns <jahns@dkrz.de>
! URL: https://www.dkrz.de/redmine/projects/scales-ppm
!
! Redistribution and use in source and binary forms, with or without
! modification, are  permitted provided that the following conditions are
! met:
!
! Redistributions of source code must retain the above copyright notice,
! this list of conditions and the following disclaimer.
!
! Redistributions in binary form must reproduce the above copyright
! notice, this list of conditions and the following disclaimer in the
! documentation and/or other materials provided with the distribution.
!
! Neither the name of the DKRZ GmbH nor the names of its contributors
! may be used to endorse or promote products derived from this software
! without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
! IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
! TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
! PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER
! OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
! EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
! PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
! PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
! LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
! NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
! SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
!

MODULE ppm_ptr_bnds_remap
  USE ppm_std_type_kinds, ONLY: i4, i8, sp, dp
  IMPLICIT NONE
  PRIVATE
  INTERFACE ptr_bnds_remap
    MODULE PROCEDURE ptr_bnds_remap_i4_1d
    MODULE PROCEDURE ptr_bnds_remap_i4_2d
    MODULE PROCEDURE ptr_bnds_remap_i4_3d
    MODULE PROCEDURE ptr_bnds_remap_i4_4d
    MODULE PROCEDURE ptr_bnds_remap_i4_5d
    MODULE PROCEDURE ptr_bnds_remap_i4_6d
    MODULE PROCEDURE ptr_bnds_remap_i4_7d
    MODULE PROCEDURE ptr_bnds_remap_i8_1d
    MODULE PROCEDURE ptr_bnds_remap_i8_2d
    MODULE PROCEDURE ptr_bnds_remap_i8_3d
    MODULE PROCEDURE ptr_bnds_remap_i8_4d
    MODULE PROCEDURE ptr_bnds_remap_i8_5d
    MODULE PROCEDURE ptr_bnds_remap_i8_6d
    MODULE PROCEDURE ptr_bnds_remap_i8_7d
    MODULE PROCEDURE ptr_bnds_remap_l_1d
    MODULE PROCEDURE ptr_bnds_remap_l_2d
    MODULE PROCEDURE ptr_bnds_remap_l_3d
    MODULE PROCEDURE ptr_bnds_remap_l_4d
    MODULE PROCEDURE ptr_bnds_remap_l_5d
    MODULE PROCEDURE ptr_bnds_remap_l_6d
    MODULE PROCEDURE ptr_bnds_remap_l_7d
    MODULE PROCEDURE ptr_bnds_remap_sp_1d
    MODULE PROCEDURE ptr_bnds_remap_sp_2d
    MODULE PROCEDURE ptr_bnds_remap_sp_3d
    MODULE PROCEDURE ptr_bnds_remap_sp_4d
    MODULE PROCEDURE ptr_bnds_remap_sp_5d
    MODULE PROCEDURE ptr_bnds_remap_sp_6d
    MODULE PROCEDURE ptr_bnds_remap_sp_7d
    MODULE PROCEDURE ptr_bnds_remap_dp_1d
    MODULE PROCEDURE ptr_bnds_remap_dp_2d
    MODULE PROCEDURE ptr_bnds_remap_dp_3d
    MODULE PROCEDURE ptr_bnds_remap_dp_4d
    MODULE PROCEDURE ptr_bnds_remap_dp_5d
    MODULE PROCEDURE ptr_bnds_remap_dp_6d
    MODULE PROCEDURE ptr_bnds_remap_dp_7d
  END INTERFACE ptr_bnds_remap
  PUBLIC :: ptr_bnds_remap
CONTAINS

  ! replacement for missing pointer bounds remapping in some compilers
  SUBROUTINE ptr_bnds_remap_i4_1d(ptr, pte, lb)
    INTEGER(i4), POINTER :: ptr(:)
    INTEGER, INTENT(in) :: lb(1)
    INTEGER(i4), TARGET, INTENT(in) :: &
         pte(lb(1):)
    ptr => pte
  END SUBROUTINE ptr_bnds_remap_i4_1d
  ! replacement for missing pointer bounds remapping in some compilers
  SUBROUTINE ptr_bnds_remap_i4_2d(ptr, pte, lb)
    INTEGER(i4), POINTER :: ptr(:,:)
    INTEGER, INTENT(in) :: lb(2)
    INTEGER(i4), TARGET, INTENT(in) :: &
         pte(lb(1):,lb(2):)
    ptr => pte
  END SUBROUTINE ptr_bnds_remap_i4_2d
  ! replacement for missing pointer bounds remapping in some compilers
  SUBROUTINE ptr_bnds_remap_i4_3d(ptr, pte, lb)
    INTEGER(i4), POINTER :: ptr(:,:,:)
    INTEGER, INTENT(in) :: lb(3)
    INTEGER(i4), TARGET, INTENT(in) :: &
         pte(lb(1):,lb(2):,lb(3):)
    ptr => pte
  END SUBROUTINE ptr_bnds_remap_i4_3d
  ! replacement for missing pointer bounds remapping in some compilers
  SUBROUTINE ptr_bnds_remap_i4_4d(ptr, pte, lb)
    INTEGER(i4), POINTER :: ptr(:,:,:,:)
    INTEGER, INTENT(in) :: lb(4)
    INTEGER(i4), TARGET, INTENT(in) :: &
         pte(lb(1):,lb(2):,lb(3):,lb(4):)
    ptr => pte
  END SUBROUTINE ptr_bnds_remap_i4_4d
  ! replacement for missing pointer bounds remapping in some compilers
  SUBROUTINE ptr_bnds_remap_i4_5d(ptr, pte, lb)
    INTEGER(i4), POINTER :: ptr(:,:,:,:,:)
    INTEGER, INTENT(in) :: lb(5)
    INTEGER(i4), TARGET, INTENT(in) :: &
         pte(lb(1):,lb(2):,lb(3):,lb(4):,lb(5):)
    ptr => pte
  END SUBROUTINE ptr_bnds_remap_i4_5d
  ! replacement for missing pointer bounds remapping in some compilers
  SUBROUTINE ptr_bnds_remap_i4_6d(ptr, pte, lb)
    INTEGER(i4), POINTER :: ptr(:,:,:,:,:,:)
    INTEGER, INTENT(in) :: lb(6)
    INTEGER(i4), TARGET, INTENT(in) :: &
         pte(lb(1):,lb(2):,lb(3):,lb(4):,lb(5):,lb(6):)
    ptr => pte
  END SUBROUTINE ptr_bnds_remap_i4_6d
  ! replacement for missing pointer bounds remapping in some compilers
  SUBROUTINE ptr_bnds_remap_i4_7d(ptr, pte, lb)
    INTEGER(i4), POINTER :: ptr(:,:,:,:,:,:,:)
    INTEGER, INTENT(in) :: lb(7)
    INTEGER(i4), TARGET, INTENT(in) :: &
         pte(lb(1):,lb(2):,lb(3):,lb(4):,lb(5):,lb(6):,lb(7):)
    ptr => pte
  END SUBROUTINE ptr_bnds_remap_i4_7d
  ! replacement for missing pointer bounds remapping in some compilers
  SUBROUTINE ptr_bnds_remap_i8_1d(ptr, pte, lb)
    INTEGER(i8), POINTER :: ptr(:)
    INTEGER, INTENT(in) :: lb(1)
    INTEGER(i8), TARGET, INTENT(in) :: &
         pte(lb(1):)
    ptr => pte
  END SUBROUTINE ptr_bnds_remap_i8_1d
  ! replacement for missing pointer bounds remapping in some compilers
  SUBROUTINE ptr_bnds_remap_i8_2d(ptr, pte, lb)
    INTEGER(i8), POINTER :: ptr(:,:)
    INTEGER, INTENT(in) :: lb(2)
    INTEGER(i8), TARGET, INTENT(in) :: &
         pte(lb(1):,lb(2):)
    ptr => pte
  END SUBROUTINE ptr_bnds_remap_i8_2d
  ! replacement for missing pointer bounds remapping in some compilers
  SUBROUTINE ptr_bnds_remap_i8_3d(ptr, pte, lb)
    INTEGER(i8), POINTER :: ptr(:,:,:)
    INTEGER, INTENT(in) :: lb(3)
    INTEGER(i8), TARGET, INTENT(in) :: &
         pte(lb(1):,lb(2):,lb(3):)
    ptr => pte
  END SUBROUTINE ptr_bnds_remap_i8_3d
  ! replacement for missing pointer bounds remapping in some compilers
  SUBROUTINE ptr_bnds_remap_i8_4d(ptr, pte, lb)
    INTEGER(i8), POINTER :: ptr(:,:,:,:)
    INTEGER, INTENT(in) :: lb(4)
    INTEGER(i8), TARGET, INTENT(in) :: &
         pte(lb(1):,lb(2):,lb(3):,lb(4):)
    ptr => pte
  END SUBROUTINE ptr_bnds_remap_i8_4d
  ! replacement for missing pointer bounds remapping in some compilers
  SUBROUTINE ptr_bnds_remap_i8_5d(ptr, pte, lb)
    INTEGER(i8), POINTER :: ptr(:,:,:,:,:)
    INTEGER, INTENT(in) :: lb(5)
    INTEGER(i8), TARGET, INTENT(in) :: &
         pte(lb(1):,lb(2):,lb(3):,lb(4):,lb(5):)
    ptr => pte
  END SUBROUTINE ptr_bnds_remap_i8_5d
  ! replacement for missing pointer bounds remapping in some compilers
  SUBROUTINE ptr_bnds_remap_i8_6d(ptr, pte, lb)
    INTEGER(i8), POINTER :: ptr(:,:,:,:,:,:)
    INTEGER, INTENT(in) :: lb(6)
    INTEGER(i8), TARGET, INTENT(in) :: &
         pte(lb(1):,lb(2):,lb(3):,lb(4):,lb(5):,lb(6):)
    ptr => pte
  END SUBROUTINE ptr_bnds_remap_i8_6d
  ! replacement for missing pointer bounds remapping in some compilers
  SUBROUTINE ptr_bnds_remap_i8_7d(ptr, pte, lb)
    INTEGER(i8), POINTER :: ptr(:,:,:,:,:,:,:)
    INTEGER, INTENT(in) :: lb(7)
    INTEGER(i8), TARGET, INTENT(in) :: &
         pte(lb(1):,lb(2):,lb(3):,lb(4):,lb(5):,lb(6):,lb(7):)
    ptr => pte
  END SUBROUTINE ptr_bnds_remap_i8_7d
  ! replacement for missing pointer bounds remapping in some compilers
  SUBROUTINE ptr_bnds_remap_l_1d(ptr, pte, lb)
    LOGICAL, POINTER :: ptr(:)
    INTEGER, INTENT(in) :: lb(1)
    LOGICAL, TARGET, INTENT(in) :: &
         pte(lb(1):)
    ptr => pte
  END SUBROUTINE ptr_bnds_remap_l_1d
  ! replacement for missing pointer bounds remapping in some compilers
  SUBROUTINE ptr_bnds_remap_l_2d(ptr, pte, lb)
    LOGICAL, POINTER :: ptr(:,:)
    INTEGER, INTENT(in) :: lb(2)
    LOGICAL, TARGET, INTENT(in) :: &
         pte(lb(1):,lb(2):)
    ptr => pte
  END SUBROUTINE ptr_bnds_remap_l_2d
  ! replacement for missing pointer bounds remapping in some compilers
  SUBROUTINE ptr_bnds_remap_l_3d(ptr, pte, lb)
    LOGICAL, POINTER :: ptr(:,:,:)
    INTEGER, INTENT(in) :: lb(3)
    LOGICAL, TARGET, INTENT(in) :: &
         pte(lb(1):,lb(2):,lb(3):)
    ptr => pte
  END SUBROUTINE ptr_bnds_remap_l_3d
  ! replacement for missing pointer bounds remapping in some compilers
  SUBROUTINE ptr_bnds_remap_l_4d(ptr, pte, lb)
    LOGICAL, POINTER :: ptr(:,:,:,:)
    INTEGER, INTENT(in) :: lb(4)
    LOGICAL, TARGET, INTENT(in) :: &
         pte(lb(1):,lb(2):,lb(3):,lb(4):)
    ptr => pte
  END SUBROUTINE ptr_bnds_remap_l_4d
  ! replacement for missing pointer bounds remapping in some compilers
  SUBROUTINE ptr_bnds_remap_l_5d(ptr, pte, lb)
    LOGICAL, POINTER :: ptr(:,:,:,:,:)
    INTEGER, INTENT(in) :: lb(5)
    LOGICAL, TARGET, INTENT(in) :: &
         pte(lb(1):,lb(2):,lb(3):,lb(4):,lb(5):)
    ptr => pte
  END SUBROUTINE ptr_bnds_remap_l_5d
  ! replacement for missing pointer bounds remapping in some compilers
  SUBROUTINE ptr_bnds_remap_l_6d(ptr, pte, lb)
    LOGICAL, POINTER :: ptr(:,:,:,:,:,:)
    INTEGER, INTENT(in) :: lb(6)
    LOGICAL, TARGET, INTENT(in) :: &
         pte(lb(1):,lb(2):,lb(3):,lb(4):,lb(5):,lb(6):)
    ptr => pte
  END SUBROUTINE ptr_bnds_remap_l_6d
  ! replacement for missing pointer bounds remapping in some compilers
  SUBROUTINE ptr_bnds_remap_l_7d(ptr, pte, lb)
    LOGICAL, POINTER :: ptr(:,:,:,:,:,:,:)
    INTEGER, INTENT(in) :: lb(7)
    LOGICAL, TARGET, INTENT(in) :: &
         pte(lb(1):,lb(2):,lb(3):,lb(4):,lb(5):,lb(6):,lb(7):)
    ptr => pte
  END SUBROUTINE ptr_bnds_remap_l_7d
  ! replacement for missing pointer bounds remapping in some compilers
  SUBROUTINE ptr_bnds_remap_sp_1d(ptr, pte, lb)
    REAL(sp), POINTER :: ptr(:)
    INTEGER, INTENT(in) :: lb(1)
    REAL(sp), TARGET, INTENT(in) :: &
         pte(lb(1):)
    ptr => pte
  END SUBROUTINE ptr_bnds_remap_sp_1d
  ! replacement for missing pointer bounds remapping in some compilers
  SUBROUTINE ptr_bnds_remap_sp_2d(ptr, pte, lb)
    REAL(sp), POINTER :: ptr(:,:)
    INTEGER, INTENT(in) :: lb(2)
    REAL(sp), TARGET, INTENT(in) :: &
         pte(lb(1):,lb(2):)
    ptr => pte
  END SUBROUTINE ptr_bnds_remap_sp_2d
  ! replacement for missing pointer bounds remapping in some compilers
  SUBROUTINE ptr_bnds_remap_sp_3d(ptr, pte, lb)
    REAL(sp), POINTER :: ptr(:,:,:)
    INTEGER, INTENT(in) :: lb(3)
    REAL(sp), TARGET, INTENT(in) :: &
         pte(lb(1):,lb(2):,lb(3):)
    ptr => pte
  END SUBROUTINE ptr_bnds_remap_sp_3d
  ! replacement for missing pointer bounds remapping in some compilers
  SUBROUTINE ptr_bnds_remap_sp_4d(ptr, pte, lb)
    REAL(sp), POINTER :: ptr(:,:,:,:)
    INTEGER, INTENT(in) :: lb(4)
    REAL(sp), TARGET, INTENT(in) :: &
         pte(lb(1):,lb(2):,lb(3):,lb(4):)
    ptr => pte
  END SUBROUTINE ptr_bnds_remap_sp_4d
  ! replacement for missing pointer bounds remapping in some compilers
  SUBROUTINE ptr_bnds_remap_sp_5d(ptr, pte, lb)
    REAL(sp), POINTER :: ptr(:,:,:,:,:)
    INTEGER, INTENT(in) :: lb(5)
    REAL(sp), TARGET, INTENT(in) :: &
         pte(lb(1):,lb(2):,lb(3):,lb(4):,lb(5):)
    ptr => pte
  END SUBROUTINE ptr_bnds_remap_sp_5d
  ! replacement for missing pointer bounds remapping in some compilers
  SUBROUTINE ptr_bnds_remap_sp_6d(ptr, pte, lb)
    REAL(sp), POINTER :: ptr(:,:,:,:,:,:)
    INTEGER, INTENT(in) :: lb(6)
    REAL(sp), TARGET, INTENT(in) :: &
         pte(lb(1):,lb(2):,lb(3):,lb(4):,lb(5):,lb(6):)
    ptr => pte
  END SUBROUTINE ptr_bnds_remap_sp_6d
  ! replacement for missing pointer bounds remapping in some compilers
  SUBROUTINE ptr_bnds_remap_sp_7d(ptr, pte, lb)
    REAL(sp), POINTER :: ptr(:,:,:,:,:,:,:)
    INTEGER, INTENT(in) :: lb(7)
    REAL(sp), TARGET, INTENT(in) :: &
         pte(lb(1):,lb(2):,lb(3):,lb(4):,lb(5):,lb(6):,lb(7):)
    ptr => pte
  END SUBROUTINE ptr_bnds_remap_sp_7d
  ! replacement for missing pointer bounds remapping in some compilers
  SUBROUTINE ptr_bnds_remap_dp_1d(ptr, pte, lb)
    REAL(dp), POINTER :: ptr(:)
    INTEGER, INTENT(in) :: lb(1)
    REAL(dp), TARGET, INTENT(in) :: &
         pte(lb(1):)
    ptr => pte
  END SUBROUTINE ptr_bnds_remap_dp_1d
  ! replacement for missing pointer bounds remapping in some compilers
  SUBROUTINE ptr_bnds_remap_dp_2d(ptr, pte, lb)
    REAL(dp), POINTER :: ptr(:,:)
    INTEGER, INTENT(in) :: lb(2)
    REAL(dp), TARGET, INTENT(in) :: &
         pte(lb(1):,lb(2):)
    ptr => pte
  END SUBROUTINE ptr_bnds_remap_dp_2d
  ! replacement for missing pointer bounds remapping in some compilers
  SUBROUTINE ptr_bnds_remap_dp_3d(ptr, pte, lb)
    REAL(dp), POINTER :: ptr(:,:,:)
    INTEGER, INTENT(in) :: lb(3)
    REAL(dp), TARGET, INTENT(in) :: &
         pte(lb(1):,lb(2):,lb(3):)
    ptr => pte
  END SUBROUTINE ptr_bnds_remap_dp_3d
  ! replacement for missing pointer bounds remapping in some compilers
  SUBROUTINE ptr_bnds_remap_dp_4d(ptr, pte, lb)
    REAL(dp), POINTER :: ptr(:,:,:,:)
    INTEGER, INTENT(in) :: lb(4)
    REAL(dp), TARGET, INTENT(in) :: &
         pte(lb(1):,lb(2):,lb(3):,lb(4):)
    ptr => pte
  END SUBROUTINE ptr_bnds_remap_dp_4d
  ! replacement for missing pointer bounds remapping in some compilers
  SUBROUTINE ptr_bnds_remap_dp_5d(ptr, pte, lb)
    REAL(dp), POINTER :: ptr(:,:,:,:,:)
    INTEGER, INTENT(in) :: lb(5)
    REAL(dp), TARGET, INTENT(in) :: &
         pte(lb(1):,lb(2):,lb(3):,lb(4):,lb(5):)
    ptr => pte
  END SUBROUTINE ptr_bnds_remap_dp_5d
  ! replacement for missing pointer bounds remapping in some compilers
  SUBROUTINE ptr_bnds_remap_dp_6d(ptr, pte, lb)
    REAL(dp), POINTER :: ptr(:,:,:,:,:,:)
    INTEGER, INTENT(in) :: lb(6)
    REAL(dp), TARGET, INTENT(in) :: &
         pte(lb(1):,lb(2):,lb(3):,lb(4):,lb(5):,lb(6):)
    ptr => pte
  END SUBROUTINE ptr_bnds_remap_dp_6d
  ! replacement for missing pointer bounds remapping in some compilers
  SUBROUTINE ptr_bnds_remap_dp_7d(ptr, pte, lb)
    REAL(dp), POINTER :: ptr(:,:,:,:,:,:,:)
    INTEGER, INTENT(in) :: lb(7)
    REAL(dp), TARGET, INTENT(in) :: &
         pte(lb(1):,lb(2):,lb(3):,lb(4):,lb(5):,lb(6):,lb(7):)
    ptr => pte
  END SUBROUTINE ptr_bnds_remap_dp_7d
END MODULE ppm_ptr_bnds_remap
!
! Local Variables:
! license-project-url: "https://www.dkrz.de/redmine/projects/scales-ppm"
! mode: f90
! license-default: "bsd"
! license-markup: "doxygen"
! End:
!
